// NoPro - webwork 2007-2013

/*
 * some handy debug-functions for js/jquery
 */

// 2014-01-08 changed nopro-dragging for #dbgbox into npjq-dragging 
// 2014-03-15 bugfix npjq-dragging() add scroll X/Y for fixed obj

var crlf = "\r\n";
function scrolldown(jso) { jso.scrollTop = jso.scrollHeight; }

function dump_obj(o,here) { // debug-fn
    var info = "";
    $.each(o, function (k, v) { info += 'k=' +k+ ', v=' +v+ "\n"; });
    if(here)
	dbg(info, true);
    else
	alert(info);
}

function dbg(msg, app, cont) {
    var text = cont ? '<div class="'+ cont +'">' : '<pre>';
    if(app) {
	$('.dbginfo').append(text + msg.replace(/</g,'&lt;'));
	scrolldown($('.dbginfo')[0]);	
    } else {
	$('#dbgbox, .dbginfo').height('auto');
	$('.dbginfo').html(text + msg);
    }
}

/***
 * do init() immediately and dont use $.ready()
 */
// view dbgbox
$('body').append('<div id="dbgbox" class="box round9px fix"></div>');
$('#dbgbox')
    .css({'width': "50%", 'min-width': '350px', 'max-height': '80%', 'min-height': '100px', 'background':'white', 'padding': "0 0 14px 6px", 'z-index': lastzi=2})
    .append('<div class="npjq2move2 wintop round movx">debug-info</div>')

    .append('<div class="dbginfo ascroll rel"></div>')
//.append('<textarea class="dbginfo ascroll rel" />')	// has resize-corner 

    .append('<div class="dbgxtra abs"><div class="clix" title="info">&Theta;</div><div class="dbgxval hidden">X: | Y:</div></div>')
    .delegate('.dbgxtra .clix, .dbgxtra .clix *', 'click', function(e) {
	if($('#dbgbox .dbgxval').is(':hidden')) {
	    $('#dbgbox .dbgxval').show();
	    $(window).mousemove(function(e) {
		$('#dbgbox .dbgxval').html('X: '+e.clientX+' | Y: '+e.clientY);
	    });
	} else {
	    $('#dbgbox .dbgxval').hide();
	    $(window).off('mousemove');
	}
    })
    .append('<div class="winrsz res_se" title="resize">#</div>')
    .append('<div class="xit round clix" title="clear">O</div>')
    .delegate('.xit, .xit *', 'click', function(e) { dbg(''); return false; })
;
$('#dbgbox .dbgxtra').css({'right': '12px', 'bottom': 0, 'padding': '1px 2px', 'border': 'thin solid', 'font-size': '14px', 'background': '#E8E8FF'});
$('#dbgbox .dbgxtra .clix').css({'float': 'right', 'background': 'silver'});
$('#dbgbox .dbgxval').css({'min-width': '8.5em'});
if(is_mobile()) {
    $('#dbgbox .xit').css({'font-size': '32px'});
    $('#dbgbox')
	.delegate('.xit, .xit *', 'touchstart', function(e) { dbg(''); return false; })
	.delegate('.wintop, .dbginfo', 'touchstart', function(eve) {
	    follow = document.getElementById('dbgbox');
	    if(!follow) {
		dbg(eve.type+ ' id not found');
		return true;
	    }
	    eve.preventDefault();
	    var touch = eve.originalEvent.touches[0] || eve.originalEvent.changedTouches[0];
	    x0 = touch.clientX;
	    y0 = touch.clientY;
	    // ensure that positioning css-vals are set
	    if(!follow.style.left) { follow.style.left = follow.offsetLeft +"px"; }
	    if(!follow.style.top)  { follow.style.top  = follow.offsetTop  +"px"; }
	    fx1 = parseInt(follow.style.left);
	    fy1 = parseInt(follow.style.top);
	    $(document)
		.bind('touchmove', function(e) { return dragit(e); })
		.bind('touchend touchcancel', function(e) {
		    $(document).off('touchmove touchend touchcancel');
		    follow = null;
		    return false;
		})
	    ;
	    return false;
	});
} else {
    $('#dbgbox')
    //.delegate('.wintop', 'mousedown', function(e) { drag(this.parentNode, e, true); return false; }) // wintop already has class npjq2move2
	.delegate('.winrsz', 'mousedown', function(e) { return jq_resize(e, '#dbgbox, #dbgbox .dbginfo'); })
    ;
}
var tmp = $(window).width() - $('#dbgbox').outerWidth(true) -8;
$('#dbgbox').css({'top': '8px', 'left': tmp+'px'});
//tmp = $('#dbgbox').css('max-height');		// works with firefox only
tmp = parseInt($(window).height() * .8) + 'px';
$('.dbginfo').css({'max-height': tmp, 'min-height': '100px', 'top': '14px'});
$('.movx')
    .mousedown(function() {$('.movx:hover').css({'cursor':'move'})})
    .mouseup(function() {$('.movx:hover').css({'cursor':'crosshair'})})
    .mouseout(function() {$('.movx:hover').css({'cursor':'crosshair'})})
;
dbg("You are running jQuery version: " + JQV, false, 'txt');

function jq_clean(jqs) {
    // 
    $(jqs).clearQueue();
    $(jqs).stop();
    $(jqs).unbind();
    //$(jqs).off();
}

function recuview(o) {
    // recursive view object
    // return string

    if(typeof(o) != 'object') {
	dbg("recuview(): "+ typeof(o) +': '+o, true);
	return;
    }
    
    var dst = crlf+ '<dl>';
    $.each(o, function(k,v) {
	if(typeof(v) == 'object') {
	    dst += crlf+ '<dt>'+ k +': {</dt>';
	    dst += crlf+ '<dd>';
	    dst += recuview(o[k]);
	    dst += crlf+ '</dd><dt>}</dt>';
	} else
	    dst += crlf+ '<dt>'+ k +': '+ v +'</dt>';
    });
    dst += crlf+ '</dl>';
    return dst;
}
function flatten_js(js) {
    // re-format minified js
    return js.replace(/([}{;])/g, '$1'+crlf);
}
